#include "List.h"

List::List()
{
	mHead = NULL;
	mCurrent = NULL;
}

List::~List()
{
	Clear();
}

void List::Clear()
{
	while (mHead != NULL)
	{
		ListItem* p = mHead;
		mHead = mHead->Next;
		delete p;
	};
	mCurrent = NULL;
}

void List::Insert(string key, int value)
{
	ListItem* n = new ListItem;
	n->Value.Key = key;
	n->Value.Value = value;
	n->Prev = NULL;
	n->Next = mHead;
	if (mHead != NULL)
	{
		mHead->Prev = n;
	}
	mHead = n;
}

void List::Delete(string key)
{
	ListItem* p;
	for (p = mHead; p != NULL; p = p->Next)
	{
		if (p->Value.Key == key)
		{
			break;
		}
	}
	if (p == NULL)
	{
		return;
	}
	if (p->Prev != NULL)
	{
		p->Prev->Next = p->Next;
	}
	else
	{
		mHead = p->Next;
	}
	if (p->Next != NULL)
	{
		p->Next->Prev = p->Prev;
	}
	delete p;
}

//kdyz nenajde polozku s danym klicem, vrt -1 (uvazujeme ze value bude vzdy >=0)
int List::SearchValue(const string key)
{
	ListItem* p = mHead;
	while (p != NULL)
	{
		if (p->Value.Key == key)
			return p->Value.Value;
		p = p->Next;
	}
	return -1;
}

bool List::IsEmpty()
{
	return mHead == NULL;
}

int List::Count()
{
	int counter = 0;
	for (ListItem* p = mHead; p != NULL; p = p->Next)
	{
		counter += 1;
	}
	return counter;
}

void List::Reset()
{
	mCurrent = mHead;
}

bool List::IsEnd()
{
	return mCurrent == NULL;
}

void List::MoveNext()
{
	mCurrent = mCurrent->Next;
}

KeyValuePair List::Current()
{
	return mCurrent->Value;
}
